<<!DOCTYPE html>
<html lang="en">
<head>
	<meta charset="UTF-8">
    <!-- responsive meta tags -->
    <meta name="viewport" content="width=device-width, initial-scale=1.0, shrink-to-fit=no">
    <!-- bootstrap css -->
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.6.1/dist/css/bootstrap.min.css" integrity="sha384-zCbKRCUGaJDkqS1kPbPd7TveP5iyJE0EjAuZQTgFLD2ylzuqKfdKlfG/eSrtxUkn" crossorigin="anonymous">

    <title>Bootstrap Flex</title>
</head>
<body>

    <div class="container">
        <div class="row">
            <div class="col-md-6 mx-md-auto bg-warning">
                <h1 class="text-center">Bootstrap Flex</h1>
                
            </div>
        </div>    
    </div>
    <!-- end of container -->

    <!-- Flexbox is used to manipulate or layout elements on one direction. This can be done extensively in CSS, however using bootstrap we add the use to our elements quicker with the use of bootstrap classes. 

    To add flexbox styles to your element, you have to add d-flex class to the parent element. Each of the direct child of the parent will become a flex item.
    

    Flex Directions

    By default, adding d-flex would arrange the children/flex items into a row. For block elements, it will no longer occupy the full width of its parent. 


    flex-row starts from left to right

    flex-row-reverse starts from right to left and reverses the order of our flex.

    flex-column - will arrange our items from top to bottom and by default its children will occupy the width of its parent. 

    flex-column-reverse - does the same as flex-column, that we now start from bottom to top.  


    -->

    <h4>Flex Row</h4>
    <div class="d-flex flex-row bg-dark mb-4">
        <div class="bg-primary p-2">Flex Item 1</div>
        <div class="bg-success p-2">Flex Item 2</div>
        <div class="bg-danger p-2">Flex Item 3</div>
    </div>

    <h4>Flex Row Reverse</h4>
    <div class="d-flex flex-row-reverse bg-dark mb-4">
        <div class="bg-primary p-2">Flex Item 1</div>
        <div class="bg-success p-2">Flex Item 2</div>
        <div class="bg-danger p-2">Flex Item 3</div>
    </div>

    <h4>Flex Column</h4>
    <!-- Span as direct children of flex-parent with flex-column -->
    <div class="d-flex flex-column bg-dark mb-4">
        <div class="bg-primary p-2">Flex Item 1</div>
        <div class="bg-success p-2">Flex Item 2</div>
        <div class="bg-danger p-2">Flex Item 3</div>
    </div>

    <h4>Flex Column Reverse</h4>
    <div class="d-flex flex-column-reverse bg-dark mb-4">
        <div class="bg-primary p-2">Flex Item 1</div>
        <div class="bg-success p-2">Flex Item 2</div>
        <div class="bg-danger p-2">Flex Item 3</div>
    </div>


    <!-- Justify Content -->
    <h2 class="text-center">Justify Content</h2>
    <!-- justify-content - would allow us to change the alignment of our flex items along its main axis.

    The main axis for items arranged with flex-row is the x-axis. For flex column, this reversed, wherein the main axis for the flex-column is y-axis.    



     -->

     <h4 class="text-center">Justify Content Start</h4>
     <!-- Align our items where our main axis starts. For flex-row, the start is from the left, for flex-row-reverse it starts from the right. -->
     <div class="d-flex flex-row justify-content-start bg-dark mb-4">
         <div class="bg-primary p-2">Flex Item 1</div>
         <div class="bg-success p-2">Flex Item 2</div>
         <div class="bg-danger p-2">Flex Item 3</div>
     </div>


     <div class="d-flex flex-row-reverse justify-content-start bg-dark mb-4">
         <div class="bg-primary p-2">Flex Item 1</div>
         <div class="bg-success p-2">Flex Item 2</div>
         <div class="bg-danger p-2">Flex Item 3</div>
     </div>


     <h4 class="text-center">Justify Content End</h4>
     <!-- Align our items where our main axis starts. For flex-row, the end is from the right, for flex-row-reverse it stars from the left. -->
     <div class="d-flex flex-row justify-content-end bg-dark mb-4">
         <div class="bg-primary p-2">Flex Item 1</div>
         <div class="bg-success p-2">Flex Item 2</div>
         <div class="bg-danger p-2">Flex Item 3</div>
     </div>

     <div class="d-flex flex-row-reverse justify-content-end bg-dark mb-4">
         <div class="bg-primary p-2">Flex Item 1</div>
         <div class="bg-success p-2">Flex Item 2</div>
         <div class="bg-danger p-2">Flex Item 3</div>
     </div>


     <h4 class="text-center">Justify Content Center</h4>
     <!-- Align our items at the center of our main axis. The main axis for flex-row and flex row reverse are in the x-axis. therefore, centering our items horizontally. -->
     <div class="d-flex flex-row justify-content-center bg-dark mb-4">
         <div class="bg-primary p-2">Flex Item 1</div>
         <div class="bg-success p-2">Flex Item 2</div>
         <div class="bg-danger p-2">Flex Item 3</div>
     </div>


     <h4 class="text-center">Justify Content Center</h4>
     <div class="d-flex flex-row-reverse justify-content-center bg-dark mb-4">
         <div class="bg-primary p-2">Flex Item 1</div>
         <div class="bg-success p-2">Flex Item 2</div>
         <div class="bg-danger p-2">Flex Item 3</div>
     </div>

     <h4 class="text-center">Justify Content Between</h4>
     <!-- Align our items by adding evenly distributed spaces between our items. -->
     <div class="d-flex flex-row justify-content-between bg-dark mb-4">
         <div class="bg-primary p-2">Flex Item 1</div>
         <div class="bg-success p-2">Flex Item 2</div>
         <div class="bg-danger p-2">Flex Item 3</div>
     </div>

     <div class="d-flex flex-row-reverse justify-content-between bg-dark mb-4">
         <div class="bg-primary p-2">Flex Item 1</div>
         <div class="bg-success p-2">Flex Item 2</div>
         <div class="bg-danger p-2">Flex Item 3</div>
     </div>


     <h4 class="text-center">Justify Content Around</h4>
     <!-- Align our items by distributing space around our items. Meaning it will automatically calculate the space reamining and add that space on both sides of our element. -->

     <!-- flex-wrap will allow us to wrap our overflowing elements, such that if the children of the flex container exceeds with the width, the flex items(children) will put on the next line. -->
     <div class="d-flex flex-row justify-content-around flex-wrap bg-dark mb-4">
         <div class="bg-primary p-2">Flex Item 1</div>
         <div class="bg-success p-2">Flex Item 2</div>
         <div class="bg-danger p-2">Flex Item 3</div>
         <div class="bg-info p-2">Flex Item 4</div>
         <div class="bg-secondary p-2">Flex Item 5</div>
         <div class="bg-warning p-2">Flex Item 6</div>
     </div>

     <!-- Align items -->
     <h2 class="text-center">Align Items</h2>
     <!-- align-items - align our items vertically for flex-row and flex-row reverse. Flex-column, this will align items horizontally. -->
     <h4 class="text-center">Align Items Start</h4>
     <!-- align-items-start - align items at the start of the y-axis or cross axis

       For flex-row and flex-row reverse, the cross axis is the y-axis and the main axis is the x-axis
       
           align-items-start will vertically align our items from the start of the y-axis:
              for flex-row this is the top
              for flex-row-reverse this is the top
          For flex-column and flex-column reverse, the cross axis is the x-axis and the main axis is the x-axis.     


     -->

     <div class="d-flex flex-row align-items-start bg-dark mb-4" style="height: 300px;">
         <div class="bg-primary p-2">Flex Item 1</div>
         <div class="bg-success p-2">Flex Item 2</div>
         <div class="bg-danger p-2">Flex Item 3</div>
     </div>

      <div class="d-flex flex-row-reverse align-items-start bg-dark mb-4" style="height: 300px;">
         <div class="bg-primary p-2">Flex Item 1</div>
         <div class="bg-success p-2">Flex Item 2</div>
         <div class="bg-danger p-2">Flex Item 3</div>
     </div>

     <h4 class="text-center">Align Items End</h4>
     <!-- align-items-end will align our flex-row and flex-row-reverse at the end of y-axis, which is the bottom. for the flex-column and flex-column-reverse, it is in end of the x-axis -->
      <div class="d-flex flex-row align-items-end bg-dark mb-4" style="height: 300px;">
         <div class="bg-primary p-2">Flex Item 1</div>
         <div class="bg-success p-2">Flex Item 2</div>
         <div class="bg-danger p-2">Flex Item 3</div>
     </div>

      <div class="d-flex flex-row-reverse align-items-end bg-dark mb-4" style="height: 300px;">
         <div class="bg-primary p-2">Flex Item 1</div>
         <div class="bg-success p-2">Flex Item 2</div>
         <div class="bg-danger p-2">Flex Item 3</div>
     </div>

     <h4>Align Items Center</h4>
     <!-- align-items-center -align our items vertically for flex-row and flex-row-reverse -->
      <div class="d-flex flex-row align-items-center bg-dark mb-4" style="height: 300px;">
         <div class="bg-primary p-2">Flex Item 1</div>
         <div class="bg-success p-2">Flex Item 2</div>
         <div class="bg-danger p-2">Flex Item 3</div>
     </div>

           <div class="d-flex flex-row-reverse align-items-center bg-dark mb-4" style="height: 300px;">
         <div class="bg-primary p-2">Flex Item 1</div>
         <div class="bg-success p-2">Flex Item 2</div>
         <div class="bg-danger p-2">Flex Item 3</div>
     </div>


     <!-- align-items and justify content -->
     <h4 class="text-center">Aligning Vertically and Horizontally</h4>
           <div class="d-flex flex-row align-items-end justify-content-end bg-dark mb-4" style="height: 300px;">
         <div class="bg-primary p-2">Flex Item 1</div>
         <div class="bg-success p-2">Flex Item 2</div>
         <div class="bg-danger p-2">Flex Item 3</div>
     </div>

       <div class="d-flex flex-row align-items-end justify-content-around bg-dark mb-4" style="height: 300px;">
         <div class="bg-primary p-2">Flex Item 1</div>
         <div class="bg-success p-2">Flex Item 2</div>
         <div class="bg-danger p-2">Flex Item 3</div>
     </div>

       <div class="d-flex flex-row align-items-end justify-content-between bg-dark mb-4" style="height: 300px;">
         <div class="bg-primary p-2">Flex Item 1</div>
         <div class="bg-success p-2">Flex Item 2</div>
         <div class="bg-danger p-2">Flex Item 3</div>
     </div>

     <!-- Mini-Activity -->

     <!--

        For the first parent div:
           -Add classes to arrange/align our items:
            -arrange the items in a row
            -center the items both horizontally and vertically
         For the second parent div:
           -Add classes to arrange/align our items:
             -arrange the items in a row
             -center the items vertically
             -align items horizontally byy evenly distributing space between items

          For both parents add secondary background      


      -->
     
     <div class="d-flex flex-row align-items-center justify-content-center bg-secondary"style="height: 200px;">
         <div class="bg-success p-2">Flex 1</div>
         <div class="bg-info p-2">Flex 2</div>
         <div class="bg-primary p-2">Flex 3</div>
     </div>

     <div class="d-flex flex-row align-items-center justify-content-between bg-secondary">
         <div class="bg-success p-2">Flex 1</div>
         <div class="bg-info p-2">Flex 2</div>
         <div class="bg-primary">Flex 3</div>
     </div>

     















	

    <!-- js dependencies -->
    <script src="https://cdn.jsdelivr.net/npm/jquery@3.5.1/dist/jquery.slim.min.js" integrity="sha384-DfXdz2htPH0lsSSs5nCTpuj/zy4C+OGpamoFVy38MVBnE+IbbVYUew+OrCXaRkfj" crossorigin="anonymous"></script>
    <script src="https://cdn.jsdelivr.net/npm/popper.js@1.16.1/dist/umd/popper.min.js" integrity="sha384-9/reFTGAW83EW2RDu2S0VKaIzap3H66lZH81PoYlFhbGU+6BZp6G7niu735Sk7lN" crossorigin="anonymous"></script>
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@4.6.1/dist/js/bootstrap.min.js" integrity="sha384-VHvPCCyXqtD5DqJeNxl2dtTyhF78xXNXdkwX1CZeRusQfRKp+tA7hAShOK/B/fQ2" crossorigin="anonymous"></script>
</body>
</html>